/*
 * Copyright 1991, 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/*
 *	sssort - 
 *		Sort a sample set
 *
 *			Paul Haeberli - 1988
 */
#include "stdio.h"
#include "ss.h"
#include "math.h"

#define COLOR		1
#define DIRECTION	2
#define POSITION	4
#define SIZE		8


main(argc,argv)
int argc;
char **argv;
{
    sampleset *iss, *oss;
    int i, mode;

    if( argc<4 ) {
	fprintf(stderr,"usage: sssort in.ss out.ss [-c -d -p -s]\n");
	exit(1);
    } 
    for(i=3; i<argc; i++) {
	if(strcmp(argv[i],"-c") == 0)
	    mode |= COLOR;
	if(strcmp(argv[i],"-d") == 0)
	    mode |= DIRECTION;
	if(strcmp(argv[i],"-p") == 0)
	    mode |= POSITION;
	if(strcmp(argv[i],"-s") == 0)
	    mode |= SIZE;
    }
    iss = ssfromfile(argv[1]);
    oss = ssnew();
    sssort(iss,oss,mode);
    sstofile(argv[2],oss);
}

sssort(iss,oss,mode)
sampleset *iss, *oss; 
int mode;
{
    sample *samptab[256];
    sample *s, *ns;
    int i, pos;

    for(i=0; i<256; i++)
	samptab[i] = 0;
    s = iss->head;
    while(s) {
	pos = s->at0;
	ns = s->next;
	s->next = samptab[pos];
	samptab[pos] = s;
	s = ns;
    }
    for(i=256; i--;) {
	s = samptab[i];
	while(s) {
	    ns = s->next;
	    addsample(oss,s);
	    s = ns;
	}
    }
}
